#include "AneuMeshLoader.h"
#include <fstream>


void AneuMeshLoader::loadMesh(const std::string& filename) {
    std::ifstream file(filename);
    if (!file.is_open()) {
        throw FileIsNotFoundException();
    } else {
        std::cout << "The file was opened successfully!" << std::endl;
    }
    int number_of_nodes, dim_of_space, number_of_elems, nodes_in_elem, number_of_bounds, nodes_in_bound;

    file >> number_of_nodes;
    file >> dim_of_space;
    node.reserve(number_of_nodes);
    for (int i = 0; i < number_of_nodes; ++i) {
        Node new_node;
        new_node.node_id = i + 1;
        file >> new_node.xyz.at(0) >> new_node.xyz.at(1) >> new_node.xyz.at(2);
        node.push_back(std::move(new_node));
    }

    file >> number_of_elems;
    file >> nodes_in_elem;
    f_elem.reserve(number_of_elems);
    for (int i = 0; i < number_of_elems; ++i) {
        FiniteElement new_f_elem;
        new_f_elem.f_elem_id = i + 1;
        file >> new_f_elem.material_id;
        new_f_elem.nodes_id.reserve(nodes_in_elem);
        for (int j = 0; j < nodes_in_elem; ++j) {
            int new_id;
            file >> new_id;
            new_f_elem.nodes_id.push_back(new_id);
        }
        f_elem.push_back(std::move(new_f_elem));
    }

    file >> number_of_bounds;
    file >> nodes_in_bound;
    bf_elem.reserve(number_of_bounds);
    for (int i = 0; i < number_of_bounds; ++i) {
        BoundaryFiniteElement new_bf_elem;
        new_bf_elem.bf_elem_id = i + 1;
        file >> new_bf_elem.boundary_id;
        new_bf_elem.nodes_id.reserve(nodes_in_bound);
        for (int j = 0; j < nodes_in_bound; ++j) {
            int new_id;
            file >> new_id;
            node[new_id - 1].flag_vertex = true;
            new_bf_elem.nodes_id.push_back(new_id);
        }
        bf_elem.push_back(std::move(new_bf_elem));
    }
    file.close();
}